Index: LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/read_dust.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/read_dust.f90	(revision 5099)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/read_dust.f90	(revision 5099)
@@ -0,0 +1,75 @@
+SUBROUTINE read_dust(debutphy, step, nbjour, dust_ec)
+  USE dimphy
+  USE mod_grid_phy_lmdz
+  USE mod_phys_lmdz_para
+  USE netcdf, ONLY : nf90_get_var, nf90_nowrite, nf90_open, nf90_inq_varid
+  IMPLICIT NONE
+
+  INCLUDE "dimensions.h"
+  INCLUDE "paramet.h"
+
+  INTEGER :: step, nbjour
+  LOGICAL :: debutphy
+  real :: dust_ec(klon)
+  real :: dust_ec_glo(klon_glo)
+
+  ! as      real dust_nc(iip1,jjp1)
+  real :: dust_nc_glo(nbp_lon + 1, nbp_lat)
+  integer :: rcode
+  integer :: ncid1, varid1, ncid2, varid2
+
+  save ncid1, varid1, ncid2, varid2
+  !$OMP THREADPRIVATE(ncid1, varid1, ncid2, varid2)
+  integer :: start(4), count(4), status
+  integer :: i, j, ig
+
+  !$OMP MASTER
+  IF (is_mpi_root .AND. is_omp_root) THEN
+    if (debutphy) then
+      ncid1 = nf90_open('dust.nc', nf90_nowrite, rcode)
+      varid1 = nf90_inq_varid(ncid1, 'EMISSION', rcode)
+    endif
+
+    start(1) = 1
+    start(2) = 1
+    start(4) = 0
+
+    count(1) = nbp_lon + 1
+    count(2) = nbp_lat
+    count(3) = 1
+    count(4) = 0
+
+    start(3) = step
+
+    status = nf90_get_var(ncid1, varid1, dust_nc_glo, start, count)
+
+    ! call correctbid(iim,jjp1,dust_nc)
+    call correctbid(nbp_lon, nbp_lat, dust_nc_glo)
+
+    !--upside down + physical grid
+
+    !--OB=change jjp1 to 1 here ;
+    !----AS: OB's change is needed if lats N to S (90 to -90) in dust.nc
+    !  dust_ec(1)=MAX(dust_nc(1,jjp1),0.0)
+    dust_ec_glo(1) = MAX(dust_nc_glo(1, nbp_lat), 0.0)
+    ig = 2
+    ! DO j=2,jjm
+    DO j = 2, nbp_lat - 1
+      ! DO i = 1, iim
+      DO i = 1, nbp_lon
+        !--OB=change jjp1+1-j to j here
+        ! dust_ec(ig)=MAX(dust_nc(i,jjp1+1-j),0.0)
+        dust_ec_glo(ig) = MAX(dust_nc_glo(i, nbp_lat + 1 - j), 0.0)
+        ig = ig + 1
+      ENDDO
+    ENDDO
+    !--OB=change second 1 to jjp1 here
+    dust_ec_glo(ig) = MAX(dust_nc_glo(1, 1), 0.0)
+    ! end if master
+  ENDIF
+  !$OMP END MASTER
+  !$OMP BARRIER
+  CALL scatter(dust_ec_glo, dust_ec)
+
+  RETURN
+END SUBROUTINE read_dust
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/read_newemissions.F
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/read_newemissions.F	(revision 5098)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/read_newemissions.F	(revision 5099)
@@ -27,9 +27,7 @@
 
       INCLUDE "dimensions.h"
-c      INCLUDE 'dimphy.h'      
-      INCLUDE 'paramet.h'      
+      INCLUDE 'paramet.h'
       INCLUDE 'chem.h'      
       INCLUDE 'chem_spla.h'
-c      INCLUDE 'indicesol.h'
 
       logical debutphy, lafinphy, edgar
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/read_surface.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/read_surface.F90	(revision 5098)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/read_surface.F90	(revision 5099)
@@ -5,10 +5,9 @@
 ! ------
        USE ioipsl
-!       USE comgeomphy
        USE dimphy
        USE mod_grid_phy_lmdz
        USE mod_phys_lmdz_para
        USE iophy
-       USE netcdf, ONLY:nf90_inq_varid,nf90_noerr,nf90_get_var
+       USE netcdf, ONLY:nf90_inq_varid,nf90_noerr,nf90_get_var,nf90_nowrite,nf90_inq_varid,nf90_open
        IMPLICIT NONE
 
@@ -18,19 +17,17 @@
        character*10 name
        character*10 varname
-!
+
        real tmp_dyn(iip1,jjp1)
        real tmp_dyn_glo(nbp_lon+1,nbp_lat)
-!       real tmp_dyn_glo(nbp_lon,nbp_lat)
        REAL tmp_dyn_invers(iip1,jjp1)
        real tmp_dyn_invers_glo(nbp_lon+1,nbp_lat)
-!       real tmp_dyn_invers_glo(nbp_lon,nbp_lat)
        real tmp_fi(klon)
        real tmp_fi_glo(klon_glo)
        real surfa(klon,5)
        real surfa_glo(klon_glo,5)
-!
+
        integer ncid
        integer varid
-       real rcode
+       integer rcode
        integer start(2),count(2),status
        integer i,j,l,ig
@@ -49,5 +46,5 @@
 
        print*,'Lecture du fichier donnees_lisa.nc' 
-       ncid=NCOPN('donnees_lisa.nc',NCNOWRIT,rcode)
+       ncid=nf90_open('donnees_lisa.nc',nf90_nowrite,rcode)
 
 !JE20140526<<: check if are inversed or not the latitude grid in donnes_lisa
@@ -72,5 +69,5 @@
 !      endj(1)=jjp1
       endj(1)=nbp_lat
-      varid=NCVID(ncid,latstr,rcode)
+      varid=nf90_inq_varid(ncid,latstr,rcode)
 
           status=nf90_get_var(ncid,varid,lats_glo,startj,endj)
@@ -89,6 +86,5 @@
           varname=trim(name)//str1
        print*,'lecture variable:',varname
-          varid=NCVID(ncid,trim(varname),rcode)
-!          varid=NCVID(ncid,varname,rcode)
+          varid=nf90_inq_varid(ncid,trim(varname),rcode)
 
 !  dimensions pour les champs scalaires et le vent zonal
@@ -135,5 +131,5 @@
 !JE20140526>>
 !      call dump2d(iim,jjm-1,tmp_fi(2),'tmp_fi   ')
-!
+
           DO j=1,klon_glo
 
@@ -141,5 +137,5 @@
 
           ENDDO ! Fin de recopie du tableau
-!
+
        ENDDO ! Fin boucle 1 a 5
        print*,'Passage Grille Dyn -> Phys'
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/read_vent.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/read_vent.f90	(revision 5099)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/read_vent.f90	(revision 5099)
@@ -0,0 +1,128 @@
+SUBROUTINE read_vent(debutphy, step, nbjour, u10m_ec, v10m_ec)
+  USE dimphy
+  USE mod_grid_phy_lmdz
+  USE mod_phys_lmdz_para
+  USE netcdf, ONLY : nf90_get_var, nf90_open, nf90_inq_varid, nf90_nowrite
+  IMPLICIT NONE
+  INCLUDE "dimensions.h"
+  INCLUDE "paramet.h"
+
+  INTEGER :: step, nbjour
+  LOGICAL :: debutphy
+  real :: u10m_ec(klon), v10m_ec(klon)
+  real :: u10m_ec_glo(klon_glo), v10m_ec_glo(klon_glo)
+
+  !  real u10m_nc(iip1,jjp1) !, v10m_nc(iip1,jjm) ! dim 97x72
+  !  real v10m_nc(iip1,jjp1)  ! dim 97x73
+  real :: u10m_nc_glo(nbp_lon + 1, nbp_lat) !, v10m_nc(iip1,jjm) ! dim 97x72
+  real :: v10m_nc_glo(nbp_lon + 1, nbp_lat)  ! dim 97x73
+  integer :: rcode
+  integer :: ncidu1, varidu1, ncidv1, varidv1
+  save ncidu1, varidu1, ncidv1, varidv1
+  !$OMP THREADPRIVATE(ncidu1, varidu1, ncidv1, varidv1)
+  integer :: start(4), count(4), status
+  integer :: i, j, ig
+
+  !$OMP MASTER
+  IF (is_mpi_root .AND. is_omp_root) THEN
+    if (debutphy) then
+
+      ncidu1 = nf90_open('u10m.nc', nf90_nowrite, rcode)
+      varidu1 = nf90_inq_varid(ncidu1, 'U10M', rcode)
+      ncidv1 = nf90_open('v10m.nc', nf90_nowrite, rcode)
+      varidv1 = nf90_inq_varid(ncidv1, 'V10M', rcode)
+
+    endif
+
+    start(1) = 1
+    start(2) = 1
+    start(4) = 0
+
+    ! count(1)=iip1
+    count(1) = nbp_lon + 1
+    ! count(2)=jjp1
+    count(2) = nbp_lat
+    count(3) = 1
+    count(4) = 0
+
+    start(3) = step
+
+    status = nf90_get_var(ncidu1, varidu1, u10m_nc_glo, start, count)
+
+    status = nf90_get_var(ncidv1, varidv1, v10m_nc_glo, start, count)
+
+
+    ! print *,'beforebidcor u10m_nc', u10m_nc(1,jjp1)
+    ! print *,'beforebidcor v10m_nc', v10m_nc(1,jjp1)
+
+    !  print *,status
+    ! call correctbid(iim,jjp1,u10m_nc)
+    ! call correctbid(iim,jjp1,v10m_nc)
+    call correctbid(nbp_lon, nbp_lat, u10m_nc_glo)
+    call correctbid(nbp_lon, nbp_lat, v10m_nc_glo)
+
+    ! print *,'afterbidcor u10m_nc', u10m_nc(1,jjp1)
+    ! print *,'afterbidcor v10m_nc', v10m_nc(1,jjp1)
+
+    !--upside down + physical grid
+
+    !  u10m_ec(1)=u10m_nc(1,jjp1)
+    !  v10m_ec(1)=v10m_nc(1,jjp1)
+    u10m_ec_glo(1) = u10m_nc_glo(1, nbp_lat)
+    v10m_ec_glo(1) = v10m_nc_glo(1, nbp_lat)
+    ig = 2
+    ! DO j=2,jjm
+    !    DO i = 1, iim
+    DO j = 2, nbp_lat - 1
+      DO i = 1, nbp_lon
+        ! u10m_ec(ig)=u10m_nc(i,jjp1+1-j)
+        ! v10m_ec(ig)=v10m_nc(i,jjp1+1-j)
+        u10m_ec_glo(ig) = u10m_nc_glo(i, nbp_lat + 1 - j)
+        v10m_ec_glo(ig) = v10m_nc_glo(i, nbp_lat + 1 - j)
+        ig = ig + 1
+        ! print *,u10m_ec(ig) ,v10m_ec(ig)
+      ENDDO
+    ENDDO
+    u10m_ec_glo(ig) = u10m_nc_glo(1, 1)
+    v10m_ec_glo(ig) = v10m_nc_glo(1, 1)
+
+
+    ! end if master
+  ENDIF
+  !$OMP END MASTER
+  !$OMP BARRIER
+  CALL scatter(u10m_ec_glo, u10m_ec)
+  CALL scatter(v10m_ec_glo, v10m_ec)
+
+  ! print *,'JE  tamagno viento ig= ', ig
+  ! print *,'READ_VENT U = ',SUM(u10m_ec),MINVAL(u10m_ec),
+  ! .                                      MAXVAL(u10m_ec)
+  !  print *,'READ_VENT V = ',SUM(v10m_ec),MINVAL(v10m_ec),
+  ! .                                      MAXVAL(v10m_ec)
+  !   print *,'u v 1 ', u10m_ec(1),v10m_ec(1)
+  !   print *,'u v klon ', u10m_ec(klon),v10m_ec(klon)
+  RETURN
+END SUBROUTINE read_vent
+
+! added by JE from the nh SPLA, dyn3d/read_reanalyse.F which is not available any more
+subroutine correctbid(iim, nl, x)
+  integer :: iim, nl
+  real :: x(iim + 1, nl)
+  integer :: i, l
+  real :: zz
+
+  do l = 1, nl
+    do i = 2, iim - 1
+      if(abs(x(i, l))>1.e10) then
+        zz = 0.5 * (x(i - 1, l) + x(i + 1, l))
+        ! print*,'correction ',i,l,x(i,l),zz
+        x(i, l) = zz
+      endif
+    enddo
+  enddo
+
+  return
+end subroutine correctbid
+
+
+
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/satellite_out_spla.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/satellite_out_spla.F90	(revision 5098)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/satellite_out_spla.F90	(revision 5099)
@@ -28,5 +28,5 @@
 !            pdtphys,rlon,rlat,masque_polder)
 !  ENDIF
-!
+
 !  DO i=1,klon
 !    IF ( masque_polder(i) .EQ. 1 ) THEN
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/sediment_mod.F
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/sediment_mod.F	(revision 5098)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/sediment_mod.F	(revision 5099)
@@ -14,5 +14,4 @@
       INCLUDE "dimensions.h"
       INCLUDE "chem.h"
-c       INCLUDE "dimphy.h"
       INCLUDE "YOMCST.h"
       INCLUDE "YOECUMF.h"
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/spla_output_dat.h
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/spla_output_dat.h	(revision 5098)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/spla_output_dat.h	(revision 5099)
@@ -172,20 +172,20 @@
 !      (/ 't_max(X)', 't_max(X)', 't_max(X)', 't_max(X)', 't_max(X)',  &
 !         't_max(X)', 't_max(X)', 't_max(X)', 't_max(X)', 't_max(X)' /))
-!
+
 !  type(ctrl_out),save :: o_taue670_aqua     = ctrl_out((/ 4, 4, 4, 10, 10, 10, 10, 10, 10, 10 /), &
 !  'taue670_aqua','Tau ext 670 aqua','', &
 !      (/ 't_max(X)', 't_max(X)', 't_max(X)', 't_max(X)', 't_max(X)',  &
 !         't_max(X)', 't_max(X)', 't_max(X)', 't_max(X)', 't_max(X)' /))
-!
+
 !  type(ctrl_out),save :: o_taue670_terra     = ctrl_out((/ 4, 4, 4, 10, 10, 10, 10, 10, 10, 10 /), &
 !  'taue670_terra','Tau ext 670 terra','', &
 !      (/ 't_max(X)', 't_max(X)', 't_max(X)', 't_max(X)', 't_max(X)',  &
 !         't_max(X)', 't_max(X)', 't_max(X)', 't_max(X)', 't_max(X)' /))
-!
+
 !  type(ctrl_out),save :: o_taue865_aqua     = ctrl_out((/ 4, 4, 4, 10, 10, 10, 10, 10, 10, 10 /), &
 !  'taue865_aqua','Tau ext 865 aqua','', &
 !      (/ 't_max(X)', 't_max(X)', 't_max(X)', 't_max(X)', 't_max(X)',  &
 !         't_max(X)', 't_max(X)', 't_max(X)', 't_max(X)', 't_max(X)' /))
-!
+
 !  type(ctrl_out),save :: o_taue865_terra     = ctrl_out((/ 4, 4, 4, 10, 10, 10, 10, 10, 10, 10 /), &
 !  'taue865_terra','Tau ext 865 terra','', &
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/spla_output_write.h
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/spla_output_write.h	(revision 5098)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/spla_output_write.h	(revision 5099)
@@ -183,5 +183,5 @@
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 ! histrac_spl
-!
+
       CALL histwrite_phy( o_fluxbb              , fluxbb               )
       CALL histwrite_phy( o_fluxff              , fluxff               )
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/splaeropt_5wv_rrtm.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/splaeropt_5wv_rrtm.f90	(revision 5099)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/splaeropt_5wv_rrtm.f90	(revision 5099)
@@ -0,0 +1,168 @@
+
+! $Id: splaeropt_5wv_rrtm.F90 2644 2016-10-02 16:55:08Z oboucher $
+
+SUBROUTINE SPLAEROPT_5WV_RRTM(&
+        zdm, zdh, tr_seri, RHcl, &
+        tausum, tau)
+
+  USE DIMPHY
+  USE aero_mod
+  USE infotrac_phy, ONLY : nqtot, nbtr, tracers
+  USE phys_local_var_mod, ONLY : od550aer, od865aer, ec550aer, od550lt1aer
+
+  ! Olivier Boucher Jan 2017
+  ! Based on Mie routines on ciclad CMIP6
+
+  IMPLICIT NONE
+
+  ! Input arguments:
+
+  REAL, DIMENSION(klon, klev), INTENT(IN) :: zdh      !--m
+  REAL, DIMENSION(klon, klev), INTENT(IN) :: zdm      !--kg/m2
+  REAL, DIMENSION(klon, klev), INTENT(IN) :: RHcl     ! humidite relative ciel clair
+  REAL, DIMENSION(klon, klev, nbtr), INTENT(IN) :: tr_seri
+
+  ! Output arguments:
+
+  REAL, DIMENSION(klon, nwave, naero_tot), INTENT(OUT) :: tausum
+  REAL, DIMENSION(klon, klev, nwave, naero_tot), INTENT(OUT) :: tau
+
+  ! Local
+
+  INTEGER, PARAMETER :: las = nwave_sw
+  LOGICAL :: soluble
+
+  INTEGER :: i, k, m, iq, itr, irh, aerindex
+  INTEGER :: spsol, spinsol, la
+  INTEGER :: RH_num(klon, klev)
+  INTEGER, PARAMETER :: la443 = 1
+  INTEGER, PARAMETER :: la550 = 2
+  INTEGER, PARAMETER :: la670 = 3
+  INTEGER, PARAMETER :: la765 = 4
+  INTEGER, PARAMETER :: la865 = 5
+  INTEGER, PARAMETER :: nbre_RH = 12
+  INTEGER, PARAMETER :: naero_soluble = 2
+  INTEGER, PARAMETER :: naero_insoluble = 2
+  INTEGER, PARAMETER :: naero = naero_soluble + naero_insoluble
+
+  REAL, PARAMETER :: RH_tab(nbre_RH) = (/0., 10., 20., 30., 40., 50., 60., 70., 80., 85., 90., 95./)
+  REAL, PARAMETER :: RH_MAX = 95.
+  REAL :: delta(klon, klev), rh(klon, klev)
+  REAL :: tau_ae5wv_int   ! Intermediate computation of epaisseur optique aerosol
+  REAL :: zrho
+  CHARACTER*20 modname
+
+  ! Soluble components 1-accumulation mode soluble; 2- seasalt coarse
+  REAL :: alpha_aers_5wv(nbre_RH, las, naero_soluble)   ! Ext. coeff. ** m2/g
+  ! Insoluble components 1- Dust: 2- BC; 3- POM
+  REAL :: alpha_aeri_5wv(las, naero_insoluble)         ! Ext. coeff. ** m2/g
+
+  ! Proprietes optiques
+
+  REAL :: fact_RH(nbre_RH)
+
+  ! From here on we look at the optical parameters at 5 wavelengths:
+  ! 443nm, 550, 670, 765 and 865 nm
+  !                                   le 12 AVRIL 2006
+
+  DATA alpha_aers_5wv/ &
+          ! accumulation mode (sulfate+2% bc) soluble
+          4.632, 4.632, 4.632, 4.632, 6.206, 6.827, 7.616, 8.716, 10.514, 12.025, 14.688, 21.539, &
+          3.981, 3.981, 3.981, 3.981, 5.346, 5.923, 6.662, 7.704, 9.437, 10.914, 13.562, 20.591, &
+          3.265, 3.265, 3.265, 3.265, 4.400, 4.909, 5.565, 6.500, 8.081, 9.449, 11.943, 18.791, &
+          2.761, 2.761, 2.761, 2.761, 3.731, 4.182, 4.767, 5.606, 7.041, 8.294, 10.610, 17.118, &
+          2.307, 2.307, 2.307, 2.307, 3.129, 3.522, 4.034, 4.774, 6.052, 7.180, 9.286, 15.340, &
+
+          ! seasalt seasalt Coarse Soluble (CS)
+          0.576, 0.690, 0.738, 0.789, 0.855, 0.935, 1.046, 1.212, 1.512, 1.785, 2.258, 3.449, &
+          0.595, 0.713, 0.763, 0.814, 0.880, 0.963, 1.079, 1.248, 1.550, 1.826, 2.306, 3.507, &
+          0.617, 0.738, 0.789, 0.842, 0.911, 0.996, 1.113, 1.286, 1.592, 1.871, 2.369, 3.562, &
+          0.632, 0.755, 0.808, 0.862, 0.931, 1.018, 1.140, 1.316, 1.626, 1.909, 2.409, 3.622, &
+          0.645, 0.771, 0.825, 0.880, 0.951, 1.039, 1.164, 1.344, 1.661, 1.948, 2.455, 3.682  /
+
+  DATA alpha_aeri_5wv/ &
+          ! coarse dust insoluble
+          0.605, 0.611, 0.661, 0.714, 0.760, &
+          ! super coarse insoluble
+          0.153, 0.156, 0.158, 0.157, 0.161 /
+
+  ! Initialisations
+  tausum(:, :, :) = 0.
+  tau(:, :, :, :) = 0.
+
+  modname = 'splaeropt_5wv_rrtm'
+
+  IF (naero>naero_tot) THEN
+    CALL abort_physic(modname, 'Too many aerosol types', 1)
+  ENDIF
+
+  DO irh = 1, nbre_RH - 1
+    fact_RH(irh) = 1. / (RH_tab(irh + 1) - RH_tab(irh))
+  ENDDO
+
+  DO k = 1, klev
+    DO i = 1, klon
+      rh(i, k) = MIN(RHcl(i, k) * 100., RH_MAX)
+      RH_num(i, k) = INT(rh(i, k) / 10. + 1.)
+      IF (rh(i, k)>85.) RH_num(i, k) = 10
+      IF (rh(i, k)>90.) RH_num(i, k) = 11
+      delta(i, k) = (rh(i, k) - RH_tab(RH_num(i, k))) * fact_RH(RH_num(i, k))
+    ENDDO
+  ENDDO
+
+  itr = 0
+  DO iq = 1, nqtot
+    IF(.NOT.tracers(iq)%isInPhysics) CYCLE
+    itr = itr + 1
+    SELECT CASE(tracers(iq)%name)
+    CASE('PREC'); CYCLE                                  !--precursor
+    CASE('FINE'); soluble = .TRUE.;  spsol = 1; aerindex = 1   !--fine mode accumulation mode
+    CASE('COSS'); soluble = .TRUE.;  spsol = 2; aerindex = 2   !--coarse mode sea salt
+    CASE('CODU'); soluble = .FALSE.; spinsol = 1; aerindex = 3   !--coarse mode dust
+    CASE('SCDU'); soluble = .FALSE.; spinsol = 2; aerindex = 4   !--super coarse mode dust
+    CASE DEFAULT; CALL abort_physic(modname, 'I cannot do aerosol optics for ' // tracers(iq)%name, 1)
+    END SELECT
+
+    DO la = 1, las
+
+      !--only 550 and 865 nm are used
+      IF (la/=la550.AND.la/=la865) CYCLE
+
+      IF (soluble) THEN  !--soluble aerosol with RH dependence
+
+        DO k = 1, klev
+          DO i = 1, klon
+            tau_ae5wv_int = alpha_aers_5wv(RH_num(i, k), la, spsol) + DELTA(i, k) * &
+                    (alpha_aers_5wv(RH_num(i, k) + 1, la, spsol) - &
+                            alpha_aers_5wv(RH_num(i, k), la, spsol))
+            tau(i, k, la, aerindex) = tr_seri(i, k, itr) * zdm(i, k) * tau_ae5wv_int
+            tausum(i, la, aerindex) = tausum(i, la, aerindex) + tau(i, k, la, aerindex)
+          ENDDO
+        ENDDO
+
+      ELSE               !--cases of insoluble aerosol
+
+        DO k = 1, klev
+          DO i = 1, klon
+            tau_ae5wv_int = alpha_aeri_5wv(la, spinsol)
+            tau(i, k, la, aerindex) = tr_seri(i, k, itr) * zdm(i, k) * tau_ae5wv_int
+            tausum(i, la, aerindex) = tausum(i, la, aerindex) + tau(i, k, la, aerindex)
+          ENDDO
+        ENDDO
+
+      ENDIF
+
+    ENDDO   ! Boucle sur les longueurs d'onde
+  ENDDO     ! Boucle sur les masses de traceurs
+
+  !--AOD calculations for diagnostics
+  od550aer(:) = SUM(tausum(:, la550, 1:naero), dim = 2)
+  od865aer(:) = SUM(tausum(:, la865, 1:naero), dim = 2)
+
+  !--extinction coefficient for diagnostic
+  ec550aer(:, :) = SUM(tau(:, :, la550, 1:naero), dim = 3) / zdh(:, :)
+
+  !--aod for particles lower than 1 micron
+  od550lt1aer(:) = tausum(:, la550, 1) + tausum(:, la550, 2) * 0.3 + tausum(:, la550, 3) * 0.2
+
+END SUBROUTINE SPLAEROPT_5WV_RRTM
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/splaeropt_6bands_rrtm.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/splaeropt_6bands_rrtm.f90	(revision 5099)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/Dust/splaeropt_6bands_rrtm.f90	(revision 5099)
@@ -0,0 +1,253 @@
+
+! $Id: splaeropt_6bands_rrtm.F90 2644 2016-10-02 16:55:08Z oboucher $
+
+SUBROUTINE SPLAEROPT_6BANDS_RRTM (&
+        zdm, tr_seri, RHcl, &
+        tau_allaer, piz_allaer, cg_allaer)
+
+  USE dimphy
+  USE aero_mod
+  USE infotrac_phy, ONLY : nqtot, nbtr, tracers
+  USE phys_local_var_mod, ONLY : abs550aer
+
+  ! Olivier Boucher Jan 2017
+  ! based on Mie routines on ciclad CMIP6
+
+  IMPLICIT NONE
+
+  INCLUDE "clesphys.h"
+
+  ! Input arguments:
+
+  REAL, DIMENSION(klon, klev), INTENT(IN) :: zdm        !--hauteur des couches en kg/m2
+  REAL, DIMENSION(klon, klev), INTENT(IN) :: RHcl       ! humidite relative ciel clair
+  REAL, DIMENSION(klon, klev, nbtr), INTENT(IN) :: tr_seri
+
+  ! Output arguments:
+  ! 2= total aerosols 
+  ! 1= natural aerosols
+
+  REAL, DIMENSION(klon, klev, 2, nbands_sw_rrtm), INTENT(OUT) :: tau_allaer ! epaisseur optique aerosol
+  REAL, DIMENSION(klon, klev, 2, nbands_sw_rrtm), INTENT(OUT) :: piz_allaer ! single scattering albedo aerosol
+  REAL, DIMENSION(klon, klev, 2, nbands_sw_rrtm), INTENT(OUT) :: cg_allaer  ! asymmetry parameter aerosol
+
+  ! Local
+
+  LOGICAL :: soluble
+  INTEGER :: i, k, irh, iq, itr, inu
+  INTEGER :: aerindex, spsol, spinsol
+  INTEGER :: RH_num(klon, klev)
+
+  INTEGER, PARAMETER :: naero_soluble = 2    ! 1- accumulation soluble; 2- coarse soluble
+  INTEGER, PARAMETER :: naero_insoluble = 2  ! 1- coarse dust; 2- supercoarse dust
+  INTEGER, PARAMETER :: naero = naero_soluble + naero_insoluble
+
+  INTEGER, PARAMETER :: nbre_RH = 12
+  REAL, PARAMETER :: RH_tab(nbre_RH) = (/0., 10., 20., 30., 40., 50., 60., 70., 80., 85., 90., 95./)
+  REAL, PARAMETER :: RH_MAX = 95.
+  REAL :: delta(klon, klev), rh(klon, klev)
+  REAL :: tau_ae2b_int   ! Intermediate computation of epaisseur optique aerosol
+  REAL :: piz_ae2b_int   ! Intermediate computation of Single scattering albedo
+  REAL :: cg_ae2b_int    ! Intermediate computation of Assymetry parameter
+  REAL :: fact_RH(nbre_RH), tmp_var
+
+  REAL, DIMENSION(klon, klev, naero_tot, nbands_sw_rrtm) :: tau_ae
+  REAL, DIMENSION(klon, klev, naero_tot, nbands_sw_rrtm) :: piz_ae
+  REAL, DIMENSION(klon, klev, naero_tot, nbands_sw_rrtm) :: cg_ae
+
+  ! Proprietes optiques
+
+  REAL :: alpha_aers_6bands(nbre_RH, nbands_sw_rrtm, naero_soluble)   !--unit m2/g aer
+  REAL :: alpha_aeri_6bands(nbands_sw_rrtm, naero_insoluble)         !--unit m2/g aer
+  REAL :: cg_aers_6bands(nbre_RH, nbands_sw_rrtm, naero_soluble)      !--unitless
+  REAL :: cg_aeri_6bands(nbands_sw_rrtm, naero_insoluble)            !--unitless
+  REAL :: piz_aers_6bands(nbre_RH, nbands_sw_rrtm, naero_soluble)     !--unitless
+  REAL :: piz_aeri_6bands(nbands_sw_rrtm, naero_insoluble)           !--unitless
+
+  REAL, PARAMETER :: tau_min = 1.e-8
+  CHARACTER*20 modname
+
+  !***************************************************************************
+  !--the order of the soluble   species has to follow the spsol   index below
+  !--the order of the insoluble species has to follow the spinsol index below
+
+  DATA alpha_aers_6bands/  &
+          ! accumulation (sulfate+2% bc) mode soluble
+          5.212, 5.212, 5.212, 5.212, 6.973, 7.581, 8.349, 9.400, 11.078, 12.463, 14.857, 20.837, &
+          4.906, 4.906, 4.906, 4.906, 6.568, 7.195, 7.989, 9.088, 10.869, 12.354, 14.951, 21.545, &
+          3.940, 3.940, 3.940, 3.940, 5.291, 5.861, 6.591, 7.620, 9.332, 10.791, 13.410, 20.370, &
+          2.292, 2.292, 2.292, 2.292, 3.105, 3.493, 3.996, 4.724, 5.978, 7.084, 9.146, 15.067, &
+          0.762, 0.762, 0.762, 0.762, 1.050, 1.201, 1.401, 1.699, 2.232, 2.721, 3.675, 6.678, &
+          0.090, 0.090, 0.090, 0.090, 0.122, 0.141, 0.166, 0.204, 0.275, 0.344, 0.484, 0.973, &
+          ! coarse seasalt
+          0.547, 0.657, 0.705, 0.754, 0.817, 0.896, 1.008, 1.169, 1.456, 1.724, 2.199, 3.358, &
+          0.566, 0.679, 0.727, 0.776, 0.840, 0.920, 1.032, 1.196, 1.492, 1.760, 2.238, 3.416, &
+          0.596, 0.714, 0.764, 0.816, 0.882, 0.965, 1.081, 1.250, 1.552, 1.828, 2.310, 3.509, &
+          0.644, 0.771, 0.825, 0.880, 0.951, 1.040, 1.164, 1.345, 1.666, 1.957, 2.462, 3.700, &
+          0.640, 0.772, 0.829, 0.887, 0.965, 1.061, 1.198, 1.398, 1.758, 2.085, 2.658, 4.031, &
+          0.452, 0.562, 0.609, 0.659, 0.728, 0.813, 0.938, 1.125, 1.471, 1.797, 2.384, 3.855  /
+
+  DATA alpha_aeri_6bands/  &
+          ! coarse dust insoluble
+          0.594, 0.610, 0.619, 0.762, 0.791, 0.495, &
+          ! supercoarse dust insoluble
+          0.151, 0.152, 0.155, 0.159, 0.168, 0.167  /
+
+  DATA cg_aers_6bands/ &
+          ! accumulation (sulfate+2% bc) mode soluble
+          0.692, 0.692, 0.692, 0.692, 0.735, 0.739, 0.744, 0.749, 0.755, 0.759, 0.765, 0.772, &
+          0.690, 0.690, 0.690, 0.690, 0.736, 0.740, 0.746, 0.752, 0.760, 0.765, 0.771, 0.779, &
+          0.678, 0.678, 0.678, 0.678, 0.727, 0.733, 0.740, 0.748, 0.759, 0.766, 0.775, 0.787, &
+          0.641, 0.641, 0.641, 0.641, 0.692, 0.700, 0.710, 0.721, 0.736, 0.746, 0.760, 0.781, &
+          0.553, 0.553, 0.553, 0.553, 0.603, 0.615, 0.627, 0.643, 0.664, 0.678, 0.699, 0.735, &
+          0.343, 0.343, 0.343, 0.343, 0.386, 0.399, 0.414, 0.433, 0.460, 0.480, 0.510, 0.569, &
+          ! seasalt coarse Soluble
+          0.754, 0.770, 0.776, 0.781, 0.784, 0.791, 0.797, 0.805, 0.815, 0.822, 0.828, 0.840, &
+          0.736, 0.753, 0.759, 0.765, 0.771, 0.778, 0.785, 0.793, 0.804, 0.811, 0.820, 0.831, &
+          0.716, 0.735, 0.742, 0.748, 0.754, 0.762, 0.769, 0.778, 0.789, 0.796, 0.807, 0.819, &
+          0.704, 0.725, 0.733, 0.739, 0.745, 0.752, 0.759, 0.768, 0.778, 0.784, 0.792, 0.803, &
+          0.716, 0.737, 0.744, 0.751, 0.756, 0.763, 0.770, 0.777, 0.786, 0.790, 0.795, 0.800, &
+          0.688, 0.730, 0.741, 0.751, 0.761, 0.771, 0.782, 0.795, 0.810, 0.820, 0.833, 0.849  /
+
+  DATA cg_aeri_6bands/ &
+          ! coarse dust insoluble
+          0.801, 0.779, 0.709, 0.698, 0.710, 0.687, &
+          ! super coarse dust insoluble
+          0.862, 0.871, 0.852, 0.799, 0.758, 0.651  /
+
+  DATA piz_aers_6bands/&
+          ! accumulation (sulfate+2% bc) mode soluble
+          0.941, 0.941, 0.941, 0.941, 0.958, 0.961, 0.965, 0.969, 0.974, 0.977, 0.981, 0.987, &
+          0.941, 0.941, 0.941, 0.941, 0.959, 0.963, 0.967, 0.971, 0.976, 0.979, 0.983, 0.988, &
+          0.953, 0.953, 0.953, 0.953, 0.967, 0.971, 0.974, 0.978, 0.982, 0.984, 0.988, 0.992, &
+          0.955, 0.955, 0.955, 0.955, 0.969, 0.972, 0.976, 0.980, 0.984, 0.986, 0.989, 0.994, &
+          0.936, 0.936, 0.936, 0.936, 0.955, 0.961, 0.966, 0.972, 0.978, 0.982, 0.987, 0.993, &
+          0.792, 0.792, 0.792, 0.792, 0.848, 0.867, 0.887, 0.907, 0.931, 0.944, 0.960, 0.980, &
+          ! seasalt coarse soluble
+          1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.001, 1.000, &
+          1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, &
+          1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, &
+          1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, &
+          0.994, 0.994, 0.995, 0.995, 0.995, 0.995, 0.996, 0.996, 0.996, 0.996, 0.996, 0.996, &
+          0.976, 0.867, 0.837, 0.814, 0.796, 0.774, 0.754, 0.735, 0.713, 0.702, 0.690, 0.675  /
+
+  DATA piz_aeri_6bands/ &
+          ! coarse dust insoluble
+          0.866, 0.875, 0.915, 0.977, 0.993, 0.971, &
+          ! super coarse dust insoluble
+          0.789, 0.749, 0.791, 0.918, 0.970, 0.909  /
+
+  spsol = 0
+  spinsol = 0
+
+  modname = 'splaeropt_6bands_rrt'
+
+  IF (NSW/=nbands_sw_rrtm) THEN
+    CALL abort_physic(modname, 'Erreur NSW doit etre egal a 6 pour cette routine', 1)
+  ENDIF
+
+  DO irh = 1, nbre_RH - 1
+    fact_RH(irh) = 1. / (RH_tab(irh + 1) - RH_tab(irh))
+  ENDDO
+
+  DO k = 1, klev
+    DO i = 1, klon
+      rh(i, k) = MIN(RHcl(i, k) * 100., RH_MAX)
+      RH_num(i, k) = INT(rh(i, k) / 10. + 1.)
+      IF (rh(i, k)>85.) RH_num(i, k) = 10
+      IF (rh(i, k)>90.) RH_num(i, k) = 11
+      delta(i, k) = (rh(i, k) - RH_tab(RH_num(i, k))) * fact_RH(RH_num(i, k))
+    ENDDO
+  ENDDO
+
+  tau_ae(:, :, :, :) = 0.
+  piz_ae(:, :, :, :) = 0.
+  cg_ae(:, :, :, :) = 0.
+
+  itr = 0
+  DO iq = 1, nqtot
+    IF(.NOT.tracers(iq)%isInPhysics) CYCLE
+    itr = itr + 1
+    SELECT CASE(tracers(iq)%name)
+    CASE('PREC'); CYCLE                                  !--precursor
+    CASE('FINE'); soluble = .TRUE.;  spsol = 1; aerindex = 1   !--fine mode accumulation mode
+    CASE('COSS'); soluble = .TRUE.;  spsol = 2; aerindex = 2   !--coarse mode sea salt
+    CASE('CODU'); soluble = .FALSE.; spinsol = 1; aerindex = 3   !--coarse mode dust
+    CASE('SCDU'); soluble = .FALSE.; spinsol = 2; aerindex = 4   !--super coarse mode dust
+    CASE DEFAULT; CALL abort_physic(modname, 'I cannot do aerosol optics for ' // tracers(iq)%name, 1)
+    END SELECT
+
+    IF (soluble) THEN ! For aerosol soluble components
+
+      DO k = 1, klev
+        DO i = 1, klon
+
+          tmp_var = tr_seri(i, k, itr) * zdm(i, k) !-- g/m2
+
+          DO inu = 1, NSW
+
+            tau_ae2b_int = alpha_aers_6bands(RH_num(i, k), inu, spsol) + &
+                    delta(i, k) * (alpha_aers_6bands(RH_num(i, k) + 1, inu, spsol) - &
+                            alpha_aers_6bands(RH_num(i, k), inu, spsol))
+
+            piz_ae2b_int = piz_aers_6bands(RH_num(i, k), inu, spsol) + &
+                    delta(i, k) * (piz_aers_6bands(RH_num(i, k) + 1, inu, spsol) - &
+                            piz_aers_6bands(RH_num(i, k), inu, spsol))
+
+            cg_ae2b_int = cg_aers_6bands(RH_num(i, k), inu, spsol) + &
+                    delta(i, k) * (cg_aers_6bands(RH_num(i, k) + 1, inu, spsol) - &
+                            cg_aers_6bands(RH_num(i, k), inu, spsol))
+
+            tau_ae(i, k, aerindex, inu) = tmp_var * tau_ae2b_int
+            piz_ae(i, k, aerindex, inu) = piz_ae2b_int
+            cg_ae(i, k, aerindex, inu) = cg_ae2b_int
+
+          ENDDO
+        ENDDO
+      ENDDO
+
+    ELSE    ! For all aerosol insoluble components
+
+      DO k = 1, klev
+        DO i = 1, klon
+
+          tmp_var = tr_seri(i, k, itr) * zdm(i, k) !-- g/m2
+
+          DO inu = 1, NSW
+            tau_ae2b_int = alpha_aeri_6bands(inu, spinsol)
+            piz_ae2b_int = piz_aeri_6bands(inu, spinsol)
+            cg_ae2b_int = cg_aeri_6bands(inu, spinsol)
+
+            tau_ae(i, k, aerindex, inu) = tmp_var * tau_ae2b_int
+            piz_ae(i, k, aerindex, inu) = piz_ae2b_int
+            cg_ae(i, k, aerindex, inu) = cg_ae2b_int
+          ENDDO
+        ENDDO
+      ENDDO
+
+    ENDIF ! soluble / insoluble
+
+  ENDDO  ! nbtr
+
+  !--all (natural + anthropogenic) aerosol
+  tau_allaer(:, :, 2, :) = SUM(tau_ae(:, :, 1:naero, :), dim = 3)
+  tau_allaer(:, :, 2, :) = MAX(tau_allaer(:, :, 2, :), tau_min)
+
+  piz_allaer(:, :, 2, :) = SUM(tau_ae(:, :, 1:naero, :) * piz_ae(:, :, 1:naero, :), dim = 3) / tau_allaer(:, :, 2, :)
+  piz_allaer(:, :, 2, :) = MIN(MAX(piz_allaer(:, :, 2, :), 0.01), 1.0)
+  WHERE (tau_allaer(:, :, 2, :)<=tau_min) piz_allaer(:, :, 2, :) = 1.0
+
+  cg_allaer(:, :, 2, :) = SUM(tau_ae(:, :, 1:naero, :) * piz_ae(:, :, 1:naero, :) * cg_ae(:, :, 1:naero, :), dim = 3) / &
+          (tau_allaer(:, :, 2, :) * piz_allaer(:, :, 2, :))
+  cg_allaer(:, :, 2, :) = MIN(MAX(cg_allaer(:, :, 2, :), 0.0), 1.0)
+
+  !--no aerosol
+  tau_allaer(:, :, 1, :) = tau_min
+  piz_allaer(:, :, 1, :) = 1.0
+  cg_allaer(:, :, 1, :) = 0.0
+
+  !--waveband 2 and all aerosol (third index = 2)
+  inu = 2
+  abs550aer(:) = SUM((1 - piz_allaer(:, :, 2, inu)) * tau_allaer(:, :, 2, inu), dim = 2)
+
+END SUBROUTINE SPLAEROPT_6BANDS_RRTM
